#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,ADD10_OUT)
  __DECLARE_VAR(BOOL,EQ13_OUT)
  __DECLARE_VAR(UINT,SEL15_OUT)
  __DECLARE_VAR(BOOL,AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// PROGRAM WATERSUPPLIER
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(LWORD,CURRENTTIMEDT)
  __DECLARE_VAR(DWORD,CURRENTTIMETOD)
  __DECLARE_VAR(DWORD,SUPPLYTIME)
  __DECLARE_VAR(WORD,NOOFSUPPLY)
  __DECLARE_VAR(WORD,TIMEMONITOR)
  __DECLARE_VAR(INT,CURRENTNO)
  __DECLARE_VAR(BOOL,TESTSW)
  __DECLARE_VAR(BOOL,SVMONPL)
  __DECLARE_VAR(BOOL,READYTIMEPL)
  __DECLARE_VAR(BOOL,VALVRELAY1)
  __DECLARE_VAR(BOOL,VALVRELAY2)
  __DECLARE_VAR(BOOL,VALVRELAY3)
  __DECLARE_VAR(BOOL,READYTIME)
  __DECLARE_VAR(BOOL,READYTOCOMPARE)
  __DECLARE_VAR(BOOL,FLICK05_1)
  __DECLARE_VAR(BOOL,FLICK05_2)
  __DECLARE_VAR(BOOL,FLICK05)
  __DECLARE_VAR(BOOL,N1SUPPLY)
  __DECLARE_VAR(BOOL,N2SUPPLY)
  __DECLARE_VAR(BOOL,N3SUPPLY)
  __DECLARE_VAR(BOOL,N4SUPPLY)
  __DECLARE_VAR(BOOL,N5SUPPLY)
  __DECLARE_VAR(BOOL,N6SUPPLY)
  __DECLARE_VAR(BOOL,N7SUPPLY)
  __DECLARE_VAR(BOOL,N8SUPPLY)
  __DECLARE_VAR(BOOL,N9SUPPLY)
  __DECLARE_VAR(BOOL,SUPPLYTRIG)
  __DECLARE_VAR(BOOL,INSUPPLY)
  __DECLARE_VAR(BOOL,CNTEND)
  __DECLARE_VAR(BOOL,VALVEON)
  __DECLARE_VAR(BOOL,VALVEUP)
  __DECLARE_VAR(BOOL,CNTEND1)
  __DECLARE_VAR(BOOL,INTERVAL)
  __DECLARE_VAR(BOOL,INTERVALUP)
  __DECLARE_VAR(BOOL,TESTMODE)
  __DECLARE_VAR(BOOL,TESTTRIGER)
  __DECLARE_VAR(BOOL,NEXTINTERVAL1)
  __DECLARE_VAR(BOOL,NEXTTRIGER)
  __DECLARE_VAR(BOOL,DRVVALV0)
  __DECLARE_VAR(BOOL,DRVVALV1)
  __DECLARE_VAR(BOOL,DRVVALV2)
  TON TON0;
  TON TON1;
  TON TON2;
  CTD CTD0;
  TON TON3;
  TON TON4;
  TON TON5;
  R_TRIG R_TRIG1;
  __DECLARE_VAR(BOOL,MOVE237_ENO)
  __DECLARE_VAR(DWORD,MOVE237_OUT)
  __DECLARE_VAR(DT,LWORD_TO_DT8_OUT)
  __DECLARE_VAR(TOD,DATE_AND_TIME_TO_TIME_OF_DAY9_OUT)
  __DECLARE_VAR(DWORD,TOD_TO_DWORD10_OUT)
  __DECLARE_VAR(WORD,DWORD_TO_WORD273_OUT)
  __DECLARE_VAR(BOOL,GT37_ENO)
  __DECLARE_VAR(BOOL,GT37_OUT)
  R_TRIG R_TRIG2;
  __DECLARE_VAR(BOOL,MOVE52_ENO)
  __DECLARE_VAR(DWORD,MOVE52_OUT)
  __DECLARE_VAR(BOOL,GT40_ENO)
  __DECLARE_VAR(BOOL,GT40_OUT)
  R_TRIG R_TRIG3;
  __DECLARE_VAR(BOOL,MOVE64_ENO)
  __DECLARE_VAR(DWORD,MOVE64_OUT)
  __DECLARE_VAR(BOOL,GT62_ENO)
  __DECLARE_VAR(BOOL,GT62_OUT)
  R_TRIG R_TRIG4;
  __DECLARE_VAR(BOOL,MOVE75_ENO)
  __DECLARE_VAR(DWORD,MOVE75_OUT)
  __DECLARE_VAR(BOOL,GT81_ENO)
  __DECLARE_VAR(BOOL,GT81_OUT)
  R_TRIG R_TRIG5;
  __DECLARE_VAR(BOOL,MOVE89_ENO)
  __DECLARE_VAR(DWORD,MOVE89_OUT)
  __DECLARE_VAR(BOOL,GT95_ENO)
  __DECLARE_VAR(BOOL,GT95_OUT)
  R_TRIG R_TRIG6;
  __DECLARE_VAR(BOOL,MOVE103_ENO)
  __DECLARE_VAR(DWORD,MOVE103_OUT)
  __DECLARE_VAR(BOOL,GT109_ENO)
  __DECLARE_VAR(BOOL,GT109_OUT)
  R_TRIG R_TRIG7;
  __DECLARE_VAR(BOOL,MOVE117_ENO)
  __DECLARE_VAR(DWORD,MOVE117_OUT)
  __DECLARE_VAR(BOOL,GT123_ENO)
  __DECLARE_VAR(BOOL,GT123_OUT)
  R_TRIG R_TRIG8;
  __DECLARE_VAR(BOOL,MOVE131_ENO)
  __DECLARE_VAR(DWORD,MOVE131_OUT)
  __DECLARE_VAR(BOOL,GT137_ENO)
  __DECLARE_VAR(BOOL,GT137_OUT)
  R_TRIG R_TRIG9;
  __DECLARE_VAR(BOOL,MOVE145_ENO)
  __DECLARE_VAR(DWORD,MOVE145_OUT)
  __DECLARE_VAR(BOOL,GT151_ENO)
  __DECLARE_VAR(BOOL,GT151_OUT)
  R_TRIG R_TRIG10;
  __DECLARE_VAR(BOOL,MOVE159_ENO)
  __DECLARE_VAR(DWORD,MOVE159_OUT)
  R_TRIG R_TRIG11;
  R_TRIG R_TRIG12;
  R_TRIG R_TRIG13;
  R_TRIG R_TRIG14;
  R_TRIG R_TRIG15;
  R_TRIG R_TRIG16;
  R_TRIG R_TRIG17;
  R_TRIG R_TRIG18;
  R_TRIG R_TRIG19;
  R_TRIG R_TRIG20;
  R_TRIG R_TRIG21;
  R_TRIG R_TRIG22;
  R_TRIG R_TRIG23;
  R_TRIG R_TRIG24;
  R_TRIG R_TRIG25;
  R_TRIG R_TRIG26;
  __DECLARE_VAR(TIME,DWORD_TO_TIME202_OUT)
  R_TRIG R_TRIG27;
  __DECLARE_VAR(BOOL,EQ288_OUT)
  __DECLARE_VAR(BOOL,EQ294_OUT)
  __DECLARE_VAR(BOOL,EQ305_OUT)

} WATERSUPPLIER;

void WATERSUPPLIER_init__(WATERSUPPLIER *data__, BOOL retain);
// Code part
void WATERSUPPLIER_body__(WATERSUPPLIER *data__);
#endif //__POUS_H
