TYPE
  LOGLEVEL : (CRITICAL, WARNING, INFO, DEBUG) := INFO;
END_TYPE

FUNCTION_BLOCK LOGGER
  VAR_INPUT
    TRIG : BOOL;
    MSG : STRING;
    LEVEL : LOGLEVEL := INFO;
  END_VAR
  VAR
    TRIG0 : BOOL;
  END_VAR

  IF TRIG AND NOT TRIG0 THEN
  {{
   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  }}
  END_IF;
  TRIG0:=TRIG;
END_FUNCTION_BLOCK



FUNCTION_BLOCK python_eval
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_poll
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_gear
  VAR_INPUT
    N : UINT;
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    py_eval : python_eval;
    COUNTER : UINT;
    ADD10_OUT : UINT;
    EQ13_OUT : BOOL;
    SEL15_OUT : UINT;
    AND7_OUT : BOOL;
  END_VAR

  ADD10_OUT := ADD(COUNTER, 1);
  EQ13_OUT := EQ(N, ADD10_OUT);
  SEL15_OUT := SEL(EQ13_OUT, ADD10_OUT, 0);
  COUNTER := SEL15_OUT;
  AND7_OUT := AND(EQ13_OUT, TRIG);
  py_eval(TRIG := AND7_OUT, CODE := CODE);
  ACK := py_eval.ACK;
  RESULT := py_eval.RESULT;
END_FUNCTION_BLOCK


PROGRAM WaterSupplier
  VAR
    CurrentTimeDT : LWORD;
    CurrentTimeTOD : DWORD;
    SupplyTime : DWORD;
    NoOfSupply : WORD;
    TimeMonitor : WORD;
    CurrentNo : INT;
    TestSw : BOOL;
    SvMonPL : BOOL;
    ReadyTimePL : BOOL;
    ValvRelay1 : BOOL;
    ValvRelay2 : BOOL;
    ValvRelay3 : BOOL;
    ReadyTime : BOOL;
    ReadyToCompare : BOOL;
    Flick05_1 : BOOL;
    Flick05_2 : BOOL;
    Flick05 : BOOL;
    N1Supply : BOOL;
    N2Supply : BOOL;
    N3Supply : BOOL;
    N4Supply : BOOL;
    N5Supply : BOOL;
    N6Supply : BOOL;
    N7Supply : BOOL;
    N8Supply : BOOL;
    N9Supply : BOOL;
    SupplyTrig : BOOL;
    InSupply : BOOL;
    CntEnd : BOOL;
    ValveOn : BOOL;
    ValveUp : BOOL;
    CntEnd1 : BOOL;
    Interval : BOOL;
    IntervalUp : BOOL;
    TestMode : BOOL;
    TestTriger : BOOL;
    NextInterval1 : BOOL;
    NextTriger : BOOL;
    DrvValv0 : BOOL;
    DrvValv1 : BOOL;
    DrvValv2 : BOOL;
  END_VAR
  VAR
    TON0 : TON;
    TON1 : TON;
    TON2 : TON;
    CTD0 : CTD;
    TON3 : TON;
    TON4 : TON;
    TON5 : TON;
    R_TRIG1 : R_TRIG;
    MOVE237_ENO : BOOL;
    MOVE237_OUT : DWORD;
    LWORD_TO_DT8_OUT : DT;
    DATE_AND_TIME_TO_TIME_OF_DAY9_OUT : TOD;
    TOD_TO_DWORD10_OUT : DWORD;
    DWORD_TO_WORD273_OUT : WORD;
    GT37_ENO : BOOL;
    GT37_OUT : BOOL;
    R_TRIG2 : R_TRIG;
    MOVE52_ENO : BOOL;
    MOVE52_OUT : DWORD;
    GT40_ENO : BOOL;
    GT40_OUT : BOOL;
    R_TRIG3 : R_TRIG;
    MOVE64_ENO : BOOL;
    MOVE64_OUT : DWORD;
    GT62_ENO : BOOL;
    GT62_OUT : BOOL;
    R_TRIG4 : R_TRIG;
    MOVE75_ENO : BOOL;
    MOVE75_OUT : DWORD;
    GT81_ENO : BOOL;
    GT81_OUT : BOOL;
    R_TRIG5 : R_TRIG;
    MOVE89_ENO : BOOL;
    MOVE89_OUT : DWORD;
    GT95_ENO : BOOL;
    GT95_OUT : BOOL;
    R_TRIG6 : R_TRIG;
    MOVE103_ENO : BOOL;
    MOVE103_OUT : DWORD;
    GT109_ENO : BOOL;
    GT109_OUT : BOOL;
    R_TRIG7 : R_TRIG;
    MOVE117_ENO : BOOL;
    MOVE117_OUT : DWORD;
    GT123_ENO : BOOL;
    GT123_OUT : BOOL;
    R_TRIG8 : R_TRIG;
    MOVE131_ENO : BOOL;
    MOVE131_OUT : DWORD;
    GT137_ENO : BOOL;
    GT137_OUT : BOOL;
    R_TRIG9 : R_TRIG;
    MOVE145_ENO : BOOL;
    MOVE145_OUT : DWORD;
    GT151_ENO : BOOL;
    GT151_OUT : BOOL;
    R_TRIG10 : R_TRIG;
    MOVE159_ENO : BOOL;
    MOVE159_OUT : DWORD;
    R_TRIG11 : R_TRIG;
    R_TRIG12 : R_TRIG;
    R_TRIG13 : R_TRIG;
    R_TRIG14 : R_TRIG;
    R_TRIG15 : R_TRIG;
    R_TRIG16 : R_TRIG;
    R_TRIG17 : R_TRIG;
    R_TRIG18 : R_TRIG;
    R_TRIG19 : R_TRIG;
    R_TRIG20 : R_TRIG;
    R_TRIG21 : R_TRIG;
    R_TRIG22 : R_TRIG;
    R_TRIG23 : R_TRIG;
    R_TRIG24 : R_TRIG;
    R_TRIG25 : R_TRIG;
    R_TRIG26 : R_TRIG;
    DWORD_TO_TIME202_OUT : TIME;
    R_TRIG27 : R_TRIG;
    EQ288_OUT : BOOL;
    EQ294_OUT : BOOL;
    EQ305_OUT : BOOL;
  END_VAR

  TON0(IN := NOT(TestMode), PT := TIME#300S);
  ReadyTime := TON0.Q;
  TON2(IN := TON0.Q, PT := TIME#1S);
  ReadyToCompare := TON2.Q;
  TestMode := NOT(ReadyTime) AND TestSw OR TestMode;
  R_TRIG1(CLK := TestMode AND TestSw);
  TestTriger := R_TRIG1.Q;
  MOVE237_OUT := MOVE(EN := TestTriger, IN := 60, ENO => MOVE237_ENO);
  IF MOVE237_ENO THEN
      SupplyTime := MOVE237_OUT;
  END_IF;
  TON1(IN := NOT(Flick05_1), PT := TIME#500mS);
  Flick05_1 := TON1.Q;
  Flick05_2 := Flick05 AND Flick05_1;
  Flick05 := NOT(Flick05_2) AND (NOT(Flick05) AND Flick05_1 OR Flick05);
  LWORD_TO_DT8_OUT := LWORD_TO_DT(CurrentTimeDT);
  DATE_AND_TIME_TO_TIME_OF_DAY9_OUT := DATE_AND_TIME_TO_TIME_OF_DAY(LWORD_TO_DT8_OUT);
  TOD_TO_DWORD10_OUT := TOD_TO_DWORD(DATE_AND_TIME_TO_TIME_OF_DAY9_OUT);
  CurrentTimeTOD := TOD_TO_DWORD10_OUT;
  DWORD_TO_WORD273_OUT := DWORD_TO_WORD(CurrentTimeTOD);
  TimeMonitor := DWORD_TO_WORD273_OUT;
  GT37_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 28800, ENO => GT37_ENO);
  N1Supply := GT37_OUT;
  R_TRIG2(CLK := N1Supply);
  MOVE52_OUT := MOVE(EN := R_TRIG2.Q, IN := 60, ENO => MOVE52_ENO);
  IF MOVE52_ENO THEN
      SupplyTime := MOVE52_OUT;
  END_IF;
  GT40_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 32400, ENO => GT40_ENO);
  N2Supply := GT40_OUT;
  R_TRIG3(CLK := N2Supply);
  MOVE64_OUT := MOVE(EN := R_TRIG3.Q, IN := 60, ENO => MOVE64_ENO);
  IF MOVE64_ENO THEN
      SupplyTime := MOVE64_OUT;
  END_IF;
  GT62_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 36000, ENO => GT62_ENO);
  N3Supply := GT62_OUT;
  R_TRIG4(CLK := N3Supply);
  MOVE75_OUT := MOVE(EN := R_TRIG4.Q, IN := 240, ENO => MOVE75_ENO);
  IF MOVE75_ENO THEN
      SupplyTime := MOVE75_OUT;
  END_IF;
  GT81_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 39600, ENO => GT81_ENO);
  N4Supply := GT81_OUT;
  R_TRIG5(CLK := N4Supply);
  MOVE89_OUT := MOVE(EN := R_TRIG5.Q, IN := 120, ENO => MOVE89_ENO);
  IF MOVE89_ENO THEN
      SupplyTime := MOVE89_OUT;
  END_IF;
  GT95_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 43200, ENO => GT95_ENO);
  N5Supply := GT95_OUT;
  R_TRIG6(CLK := N5Supply);
  MOVE103_OUT := MOVE(EN := R_TRIG6.Q, IN := 60, ENO => MOVE103_ENO);
  IF MOVE103_ENO THEN
      SupplyTime := MOVE103_OUT;
  END_IF;
  GT109_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 46800, ENO => GT109_ENO);
  N6Supply := GT109_OUT;
  R_TRIG7(CLK := N6Supply);
  MOVE117_OUT := MOVE(EN := R_TRIG7.Q, IN := 300, ENO => MOVE117_ENO);
  IF MOVE117_ENO THEN
      SupplyTime := MOVE117_OUT;
  END_IF;
  GT123_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 50400, ENO => GT123_ENO);
  N7Supply := GT123_OUT;
  R_TRIG8(CLK := N7Supply);
  MOVE131_OUT := MOVE(EN := R_TRIG8.Q, IN := 120, ENO => MOVE131_ENO);
  IF MOVE131_ENO THEN
      SupplyTime := MOVE131_OUT;
  END_IF;
  GT137_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 54000, ENO => GT137_ENO);
  N8Supply := GT137_OUT;
  R_TRIG9(CLK := N8Supply);
  MOVE145_OUT := MOVE(EN := R_TRIG9.Q, IN := 240, ENO => MOVE145_ENO);
  IF MOVE145_ENO THEN
      SupplyTime := MOVE145_OUT;
  END_IF;
  GT151_OUT := GT(EN := ReadyTime, IN1 := CurrentTimeTOD, IN2 := 57600, ENO => GT151_ENO);
  N9Supply := GT151_OUT;
  R_TRIG10(CLK := N9Supply);
  MOVE159_OUT := MOVE(EN := R_TRIG10.Q, IN := 60, ENO => MOVE159_ENO);
  IF MOVE159_ENO THEN
      SupplyTime := MOVE159_OUT;
  END_IF;
  R_TRIG11(CLK := N1Supply);
  R_TRIG12(CLK := N2Supply);
  R_TRIG13(CLK := N3Supply);
  R_TRIG14(CLK := N4Supply);
  R_TRIG15(CLK := N5Supply);
  R_TRIG16(CLK := N6Supply);
  R_TRIG17(CLK := N7Supply);
  R_TRIG18(CLK := N8Supply);
  R_TRIG19(CLK := N9Supply);
  SupplyTrig := ReadyToCompare AND (R_TRIG11.Q OR R_TRIG12.Q OR R_TRIG13.Q OR R_TRIG14.Q OR R_TRIG15.Q OR R_TRIG16.Q OR R_TRIG17.Q OR R_TRIG18.Q OR R_TRIG19.Q);
  InSupply := NOT(CntEnd1) AND (NOT(InSupply) AND SupplyTrig OR InSupply);
  R_TRIG20(CLK := ValveUp);
  R_TRIG21(CLK := InSupply);
  CTD0(CD := R_TRIG20.Q, LD := R_TRIG21.Q, PV := 3);
  CntEnd := CTD0.Q;
  R_TRIG22(CLK := CTD0.Q);
  CntEnd1 := R_TRIG22.Q;
  CurrentNo := CTD0.CV;
  R_TRIG23(CLK := InSupply);
  R_TRIG24(CLK := TestTriger);
  R_TRIG25(CLK := InSupply);
  R_TRIG26(CLK := TestTriger);
  ValveOn := InSupply AND NOT(ValveUp) AND (NOT(CntEnd) AND (IntervalUp OR R_TRIG23.Q) OR R_TRIG24.Q OR ValveOn) OR TestMode AND NOT(ValveUp) AND (NOT(CntEnd) AND (IntervalUp OR R_TRIG25.Q) OR R_TRIG26.Q OR ValveOn);
  DWORD_TO_TIME202_OUT := DWORD_TO_TIME(SupplyTime);
  TON3(IN := ValveOn, PT := DWORD_TO_TIME202_OUT);
  ValveUp := TON3.Q;
  R_TRIG27(CLK := InSupply);
  Interval := InSupply AND NOT(IntervalUp) AND (NOT(CntEnd) AND (NextTriger OR R_TRIG27.Q) OR Interval);
  TON4(IN := Interval, PT := TIME#1200S);
  IntervalUp := TON4.Q;
  NextInterval1 := InSupply AND NOT(NextTriger) AND (IntervalUp OR NextInterval1);
  TON5(IN := NextInterval1, PT := TIME#10mS);
  NextTriger := TON5.Q;
  EQ288_OUT := EQ(CurrentNo, 3);
  DrvValv0 := EQ288_OUT;
  ValvRelay1 := (DrvValv0 OR TestMode) AND ValveOn;
  EQ294_OUT := EQ(CurrentNo, 2);
  DrvValv1 := EQ294_OUT;
  ValvRelay2 := DrvValv1 AND ValveOn;
  EQ305_OUT := EQ(CurrentNo, 1);
  DrvValv2 := EQ305_OUT;
  ValvRelay3 := DrvValv2 AND ValveOn;
  SvMonPL := Flick05 AND InSupply OR ValveOn;
  ReadyTimePL := Flick05 AND NOT(TestMode) AND NOT(ReadyTime) OR Flick05_1 AND TestMode OR ReadyTime;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK task0(INTERVAL := T#20ms,PRIORITY := 0);
    PROGRAM instance0 WITH task0 : WaterSupplier;
  END_RESOURCE
END_CONFIGURATION
